com.pixelmed.anatproc

## Class DictionaryOfConcepts

- java.lang.Object
- - com.pixelmed.anatproc.DictionaryOfConcepts

    public class DictionaryOfConcepts
    extends java.lang.Object

This class contains utility methods provide for the detection of concepts in various header attributes regardless of whether these are formal codes, code strings or free text comments.

### Field Summary

Fields
`protected java.lang.String[]` `badWords`
`protected java.util.HashMap` `codeStringEquivalentToConceptEntries`
`protected DisplayableConcept[]` `conceptEntries`
`protected java.util.HashMap<java.lang.String,DisplayableConcept>` `conceptUniqueIdentifierToConceptEntries`
`protected java.lang.String` `descriptionOfConcept`
`protected java.util.HashMap` `meaningsAndSynonymsToConceptEntries`
`protected java.util.HashMap` `schemeAndValuePairsToConceptEntries`

### Constructor Summary

Constructors
Constructor and Description
`DictionaryOfConcepts(DisplayableConcept[] conceptEntries)`
`DictionaryOfConcepts(DisplayableConcept[] conceptEntries, java.lang.String[] badWords, java.lang.String descriptionOfConcept)`

### Method Summary

Methods
`protected void` `doCommonConstructorStuff(DisplayableConcept[] conceptEntries, java.lang.String[] badWords, java.lang.String descriptionOfConcept)`
`DisplayableConcept` `find(CodedSequenceItem item)`
`DisplayableConcept` `find(Concept key)`
`DisplayableConcept` `find(SchemeAndValuePair key)`
`DisplayableConcept` `find(java.lang.String key)`
`protected DisplayableConcept` `findCodeInEntriesFirstThenTryCodeMeaningInEntriesThenTryLongestIndividualEntryContainedWithinCodeMeaning(CodedSequenceItem item)`
`DisplayableConcept` `findCodeStringExact(java.lang.String key)`
`protected DisplayableConcept` `findInEntriesFirstThenTryLongestIndividualEntryContainedWithin(java.lang.String key)`
`protected DisplayableConcept` `findLongestIndividualEntryContainedWithin(java.lang.String keyText)`
`java.lang.String` `getDescriptionOfConcept()`
`protected static java.lang.String` `removeAccentsFromLowerCaseString(java.lang.String s)`
`protected java.lang.String` `removeAnyBadWords(java.lang.String string)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### conceptEntries

    protected DisplayableConcept[] conceptEntries

#### schemeAndValuePairsToConceptEntries

    protected java.util.HashMap schemeAndValuePairsToConceptEntries

#### meaningsAndSynonymsToConceptEntries

    protected java.util.HashMap meaningsAndSynonymsToConceptEntries

#### codeStringEquivalentToConceptEntries

    protected java.util.HashMap codeStringEquivalentToConceptEntries

#### conceptUniqueIdentifierToConceptEntries

    protected java.util.HashMap<java.lang.String,DisplayableConcept> conceptUniqueIdentifierToConceptEntries

#### badWords

    protected java.lang.String[] badWords

#### descriptionOfConcept

    protected java.lang.String descriptionOfConcept

### Constructor Detail

#### DictionaryOfConcepts

    public DictionaryOfConcepts(DisplayableConcept[] conceptEntries)

#### DictionaryOfConcepts

    public DictionaryOfConcepts(DisplayableConcept[] conceptEntries,
                        java.lang.String[] badWords,
                        java.lang.String descriptionOfConcept)

### Method Detail

#### doCommonConstructorStuff

    protected void doCommonConstructorStuff(DisplayableConcept[] conceptEntries,
                                java.lang.String[] badWords,
                                java.lang.String descriptionOfConcept)

#### getDescriptionOfConcept

    public java.lang.String getDescriptionOfConcept()

#### find

    public DisplayableConcept find(SchemeAndValuePair key)

#### find

    public DisplayableConcept find(CodedSequenceItem item)

#### find

    public DisplayableConcept find(java.lang.String key)

#### find

    public DisplayableConcept find(Concept key)

#### findCodeStringExact

    public DisplayableConcept findCodeStringExact(java.lang.String key)

#### removeAnyBadWords

    protected java.lang.String removeAnyBadWords(java.lang.String string)

#### removeAccentsFromLowerCaseString

    protected static java.lang.String removeAccentsFromLowerCaseString(java.lang.String s)

#### findLongestIndividualEntryContainedWithin

    protected DisplayableConcept findLongestIndividualEntryContainedWithin(java.lang.String keyText)

#### findInEntriesFirstThenTryLongestIndividualEntryContainedWithin

    protected DisplayableConcept findInEntriesFirstThenTryLongestIndividualEntryContainedWithin(java.lang.String key)

#### findCodeInEntriesFirstThenTryCodeMeaningInEntriesThenTryLongestIndividualEntryContainedWithinCodeMeaning

    protected DisplayableConcept findCodeInEntriesFirstThenTryCodeMeaningInEntriesThenTryLongestIndividualEntryContainedWithinCodeMeaning(CodedSequenceItem item)